require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ALPHA_CPU_H_)) {
    eval 'sub _ALPHA_CPU_H_ () {1;}' unless defined(&_ALPHA_CPU_H_);
    if(defined(&_KERNEL_OPT)) {
	require './alpha/opt_gprof.ph';
	require './alpha/opt_multiprocessor.ph';
	require './alpha/opt_lockdebug.ph';
    }
    require 'machine/alpha_cpu.ph';
    if(defined(&_KERNEL) || defined(&_KMEMUSER)) {
	require 'sys/cpu_data.ph';
	require 'sys/cctr.ph';
	require 'sys/intr.ph';
	require 'machine/frame.ph';
	if(defined(&GPROF)  && defined(&MULTIPROCESSOR)) {
	}
    }
    if(defined(&_KERNEL)) {
	eval 'sub CPUF_PRIMARY () {0x1;}' unless defined(&CPUF_PRIMARY);
	eval 'sub CPUF_PRESENT () {0x2;}' unless defined(&CPUF_PRESENT);
	eval 'sub CPUF_RUNNING () {0x4;}' unless defined(&CPUF_RUNNING);
	eval 'sub CPUF_PAUSED () {0x8;}' unless defined(&CPUF_PAUSED);
	eval 'sub CPU_INFO_ITERATOR () {\'int\'  &__unused;}' unless defined(&CPU_INFO_ITERATOR);
	eval 'sub CPU_INFO_FOREACH {
	    my($cii, $ci) = @_;
    	    eval q($ci =  &cpu_info_list; $ci !=  &NULL; $ci =  ($ci->{ci_next}));
	}' unless defined(&CPU_INFO_FOREACH);
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub curlwp () {( &alpha_pal_rdval());}' unless defined(&curlwp);
	    eval 'sub curcpu () {
	        eval q( ($curlwp->{l_cpu}));
	    }' unless defined(&curcpu);
	    eval 'sub CPU_IS_PRIMARY {
	        my($ci) = @_;
    		eval q((($ci)-> &ci_flags &  &CPUF_PRIMARY));
	    }' unless defined(&CPU_IS_PRIMARY);
	} else {
	    eval 'sub curcpu () {
	        eval q(( &cpu_info_primary));
	    }' unless defined(&curcpu);
	    eval 'sub curlwp () { &curcpu()-> &ci_curlwp;}' unless defined(&curlwp);
	}
	eval 'sub cpu_number () {
	    eval q( &alpha_pal_whami());
	}' unless defined(&cpu_number);
	eval 'sub cpu_proc_fork {
	    my($p1, $p2) = @_;
    	    eval q();
	}' unless defined(&cpu_proc_fork);
	eval 'sub CLKF_USERMODE {
	    my($framep) = @_;
    	    eval q(((($framep)-> ($cf_tf->{tf_regs[&FRAME_PS]}) &  &ALPHA_PSL_USERMODE) != 0));
	}' unless defined(&CLKF_USERMODE);
	eval 'sub CLKF_PC {
	    my($framep) = @_;
    	    eval q((($framep)-> ($cf_tf->{tf_regs[&FRAME_PC]})));
	}' unless defined(&CLKF_PC);
	eval 'sub CLKF_INTR {
	    my($framep) = @_;
    	    eval q((( &curcpu()-> &ci_intrdepth & 0xf) != 0));
	}' unless defined(&CLKF_INTR);
	eval 'sub LWP_PC {
	    my($p) = @_;
    	    eval q((( &l)-> ($l_md->{md_tf}->{tf_regs[&FRAME_PC]})));
	}' unless defined(&LWP_PC);
	eval 'sub aston {
	    my($l) = @_;
    	    eval q((($l)-> ($l_md->{md_astpending}) = 1));
	}' unless defined(&aston);
    }
    eval 'sub CPU_CONSDEV () {1;}' unless defined(&CPU_CONSDEV);
    eval 'sub CPU_ROOT_DEVICE () {2;}' unless defined(&CPU_ROOT_DEVICE);
    eval 'sub CPU_UNALIGNED_PRINT () {3;}' unless defined(&CPU_UNALIGNED_PRINT);
    eval 'sub CPU_UNALIGNED_FIX () {4;}' unless defined(&CPU_UNALIGNED_FIX);
    eval 'sub CPU_UNALIGNED_SIGBUS () {5;}' unless defined(&CPU_UNALIGNED_SIGBUS);
    eval 'sub CPU_BOOTED_KERNEL () {6;}' unless defined(&CPU_BOOTED_KERNEL);
    eval 'sub CPU_FP_SYNC_COMPLETE () {7;}' unless defined(&CPU_FP_SYNC_COMPLETE);
    eval 'sub CPU_CCTR () {8;}' unless defined(&CPU_CCTR);
    eval 'sub CPU_IS_QEMU () {9;}' unless defined(&CPU_IS_QEMU);
    eval 'sub CPU_FP_COMPLETE_DEBUG () {10;}' unless defined(&CPU_FP_COMPLETE_DEBUG);
    if(defined(&_KERNEL)) {
	eval 'sub cpu_idle () {
	    eval q((* &cpu_idle_fn)());
	}' unless defined(&cpu_idle);
    }
}
1;
